<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99i                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//DON'T TOUCH THIS 5 SECURITY LINES
	if(!defined('_phpipblocker_dir_'))
		die('Nothing to see here');
	$ipblocker_listLocation = array();
	$ipblocker_exclusion = array();
	$ipblocker_config = array();
//AFTER THIS LINE YOU CAN MODIFY YOUR SCRIPT CONFIGURATION ;)

//** MYSQL CONFIGURATION **
	//db_name: the name of the database to use, if the database specified below doesn't exists it will be automatically created
	$ipblocker_config['db_name'] = 'my_evcz';
	//db_table_name: the name of the table where the date will be stored (automatically (re)created)
	$ipblocker_config['db_table_name'] = 'ipblocker';
	$ipblocker_config['db_user'] = 'evcz';
	$ipblocker_config['db_pass']= '';
	$ipblocker_config['db_server'] = 'localhost';
			
	//During the install/upgrade do you want to insert all the data with an unique query? true or false
	//best performance with true... in some case it works only with false... using 'false' every blocklist line generate a query... (a blocklist with 50.000 entrie generate 50.000 queries)
	$ipblocker_config['unique_query'] = true;
	//lines_per_query: how many ranges will be added in the database with a sigle query?
	//this option is influenced by 'max_allowed_packet' of the mysql server config... with huge lists (>1 mb) may go out of bound on some servers... so we split the query ;)
	//using excessive values may produce strange errors (lot of ranges not added in the db...) increase it only if you know what you are doing ;)
	$ipblocker_config['lines_per_query']  = 10000;

	//use persistent connection? true or false? (in 99.9% of cases it must be set as false)
	$ipblocker_config['persistent'] = false;

	//disconnect from the sql server at the end? (generally must be set to true, set it as false ONLY if your website doesn't work using true)
	$ipblocker_config['disconnect'] = true;
	
	//!!! IF YOU ENABLE THE CACHE YOU NEED TO RE-INSTALL THE SCRIPT !!!
	//enable the use of the cache to cache 'granted' ips?
	$ipblocker_config['caching_enable'] = false;
	$ipblocker_config['caching_table'] = 'ipblocker_cache';
	//max time to store a 'granted' ip (in seconds)
	//after this time it will be re-checked against the lists
	$ipblocker_config['caching_timeout'] = '300';
	
	//** FIND_BADDIES settings
		//
		//If you want to use this tool read docs/find_baddies.txt before anything ;)
		//
		//FIND_BADDIES section [necessary only if you plan to use find_baddies.php]
		//this settings are related to a tool that scan all the members of your forum to find users
		//registered using "bad ips"...
		//
		//!!! the find_baddies.php file is protected after the first run, otherwise someone can abuse it overloading your server !!!		
		//if you want to run another volta time, simply delete the file phpipblocker/FIND_BADDIES.LOCK
		//
		//to be able to use the find_baddies tool you need to deleted the file phpipblocker/FIND_BADDIES.LOCK
		//put here the database name where your forum is located
		$ipblocker_config['find_baddies_db_name'] = 'forum_dbname';
		//the type of the forum you want to check with the find_baddies.php;
		//for other applications use "myapp" and set your custom tables name in the find_baddies.php file ;)
		//available options: ibp_users, ipb_posts, vb_users, vb_posts, phpbb_posts
		$ipblocker_config['forum_app_type'] = 'ipb_users';
		//do you want to skip the check of fakes ips like 10.x.x.x, 127.x.x.x, 172.x.x.x, 244.x.x.x and other LAN/PRIVATE USE ips? true or false
		//(the most diffused forums generally record the ip forwaded by the proxy/nat that in some case is an ip relative to an internal lan...)
		$ipblocker_config['find_baddies_skip_fakes'] = false;
		//if you have previously used a tool to reset the ips of your staff set here the ip you have used to do the reset, so that ip will be ignored
		//if you don't have run any similar tool simply don't modify the line below ;)
		$ipblocker_config['find_baddies_reset_ip'] = '255.255.255.256';


//** AUTO-UPDATE **
	//************************************************************
	//WE SUGGEST THE USE OF REALCRON INSTEAD OF FAKECRON!
	//************************************************************
	
	// !!! for more infos read docs/auto_updater.txt !!!
	
	//enable the use of update_cron.php? true or false
	//set it as false if you don't want to use the cron script!
	$ipblocker_config['realcron_enabled'] = false;
		//key to specify in the script url to enable the cron...
		//NOTE: this setting need to be setted only if you plan to use the realcron system otherwise ignore it ;)
		//if you don't specify a new key, some people can abuse update_cron.php calling it several times via the web browser with the result being the overloading of your server!
		//we suggest to use a key formed by letters and numbers...
		//the key can be as long as you want... we suggest to use a key longer at least 6 characters ;)
		//(Note: if you left this setting empty the realcron will be automatically disabled)
		$ipblocker_config['cron_access_key'] = '';
	
	//!!! deprecated !!! use only if you haven't access to cronjobs !
	//enable the use of phpfakecron system? (update using the img string in the footer of your website)
	//set it as false if you don't want to use the phpfakecron system!
	$ipblocker_config['fakecron_enabled'] = false;
		//NOTE: this setting need to be setted only if you plan to use the fakecron system otherwise ignore it ;)
		//fakecron_lastrun_chmod: the chmod that will be assigned to the update.lastrun.php file
		//it must be writable by the fakecron system (tha file contain the lastupdate data to control if it's the time to do or not the update)
		//REMEMBER TO PUT THE 0(zero) AT THE START! chmod command is in base8 ;)
		$ipblocker_config['fakecron_lastrun_chmod'] = 0777;
	

//** EMAIL **
	//email of the website admin (used in email notification and error page)
	$ipblocker_config['adminMail'] = 'foo@domain.xyz';

	//send out a detailed mail when a blocklisted ip contact you? true or false
	$ipblocker_config['sendMail'] = false;

	//do you want to ignore the notification mail when a range with a name that contain some words visit a page?
	//this function is necessary to avoid tons of mail getting delivered after a "scan" from inktomi or websense crawlers :D
	//just type the words (case insensitive) you want to exclude separated by a |
	//this option influence *ONLY* the email sending, doesn't influence the block nor the logging ;)
	//if you don't want to use this feature simply leave this string empty
	$ipblocker_config['notNotifyMail'] = 'inktomi|websense|google|spider|alexa';


//** LOGGING **
	//log unwanted access? true or false
	$ipblocker_config['logAccess'] = true;
	
		//do you want to ignore the logging when a range with a name that contain some words visit a page?
		//just type the words (case insensitive) you want to exclude separated by a |
		//this option influence *ONLY* the loggin sending, doesn't influence the block nor the mail nor the mysql logging ;)
		//if you don't want to use this feature simply leave this string empty :P
		$ipblocker_config['notLogRanges'] = 'inktomi|websense|google|spider|microsoft|alexa';
		
		//full path of the directory where logs files will be saved (must end with / or \\)
		//this dir will be automatically created during the install process (if doesn't exists)
		$ipblocker_config['fullpathLogName'] = '/membri/evcz/logaccess/';
		
		//chmod that will be assigned to fullpathLogName (generally 777 is need to work properly)
		//REMEMBER TO PUT THE 0(zero) AT THE START! chmod command is in base8 ;)
		$ipblocker_config['fullpathLogName_chmod'] = 0777;
		
		//how often you want to archive the log?
		//a new log file (with new name) will be created every:
		$ipblocker_config['logFrequency'] = 'month';
		//all options available are:
		//$ipblocker_config['logFrequency'] = 'day';
		//$ipblocker_config['logFrequency'] = 'month';
		//$ipblocker_config['logFrequency'] = 'year';
			//another options is to set a fix filename if you don't want to archive it
			//change 'filename.log' with the filename you want to use (it will be saved in the dir specified before)
			//$ipblocker_config['logFrequency'] = 'filename.log';
	
	//date format
	//the format of the date/hours saved in the log files
	//config same as http://www.php.net/date
	//default = d M Y H:i:s => day month year Hour:minutes:seconds
	$ipblocker_config['date_format'] = 'd M Y H:i:s';

	//only for debug purpose!
	//total_logging: log ALL the ips connections (true or false)
	$ipblocker_config['total_logging'] = false;

		//filename of the log... it will be saved in the 'fullpathLogname' dir explained before
		$ipblocker_config['total_logging_filename'] = 'total_logger.log';
	
		//default: 262144 bytes = 256 kbytes
		//the bigger this value is, higher the server load will be...
		//take in mind that the data saved in this file will be loaded into the server memory (to split correctly the file)
		//however this script autoempty the memory used when the process is completed ;)
		//NOTE: set it as 0 for no limit (no split = very low server load ^_')
		$ipblocker_config['total_logging_filesize'] = 262144;

	//MYSQL LOGGING (not ready)
	//activate sql logging system? note that it is slower than textlogging!
	//$ipblocker_config['db_logging_active'] = false;
	//db_name: the name of the database to use, if the database specified below doesn't exists it will be automatically created
	//$ipblocker_config['db_logging_name'] = 'my_evcz';
	//db_table_name: the name of the table where the logs will be stored (automatically (re)created)
	//$ipblocker_config['db_logging_table_name'] = 'ipblocker_logs';
	//do you want to ignore the mysql logging when a range with a name that contain some words visit a page?
	//just type the words (case insensitive) you want to exclude separated by a |
	//this option influence *ONLY* the loggin sending, doesn't influence the block nor the mail nor the textloggin ;)
	//if you don't want to use this feature simply leave this string empty :P
	//$ipblocker_config['db_logging_notLogRanges'] = 'inktomi|websense|google|spider|alexa';
	//mysql frontend access key
	//you must set a key to access at phpipblocker/mysql_frontend.php
	//$ipblocker_config['db_logging_key'] = '';


//** PROXY CHECKING **
	//control if the user is behind a TRANSPARENT proxy and try to retrieve his original ip (declared by the proxy, not 100% affidable)
	//the script automatically reject (don't consider the declared ip) the ips that appartain to local network ranges ( 10.x.x.x and 172.x.x.x and 127.x.x.x and others)
	//in that cases it consider only the real ip that requested the page to the server ;)
	//true or false
	$ipblocker_config['proxyCheck']= true;
	
	
//** BLOCKING **
	//block unwanted access? true or false
	$ipblocker_config['blockThem']= true;

		//$ipblocker_config['blockType']: the type of block you want to use
		//0=404error, 1=403error, 2=redirect, 3=custom error (see docs/template.txt)
		$ipblocker_config['blockType'] = 3;

			//$ipblocker_config['blockRedirectURL'] (necessary only if $ipblocker_config['blockType'] = 2)
			$ipblocker_config['blockRedirectURL'] = 'http://www.google.com/';


//** HOSTNAME FILTER **
	//In this section you can set up the hostname filter
	//This filter check only the ip that aren't on the loaded lists ;)

	//consider the user as "baddie" if the hostname isn't available (hostname = user ip)?
	$ipblocker_config['blockByHostname_ifEmpty'] = false;

	//conditional hostname filter
	//(consider the user as "baddie" if the hostname respect some conditions)
	//if you don't want to use this feature simply left it empty
		//examples on how to set it:
		//'.gov$|.mil$' will blocks every hostname like: *.gov or *.mil
		//'^myhost.' will blocks every hostname like: myhost.*
		//'.myhost.' will block every hostname like: *.myhost.*
	$ipblocker_config['blockByHostname_conditional'] = '.gov$|.mil$';


//** LIST LOCATIONS **
	//location of the blocklist (can be a local filename or a remote url)
	//
	//supported PLAIN TEXT, GZIP e ZIP lists
	//
	//NOTE: more lists require more server power and generate more cpu load (mostly during install/update processes)!
	//so use only the necessary lists :P
	//
	//The list format supported are:
	//peerguardian/protowall format
	//		rangename:x.x.x.x-x.x.x.x
	//donkey formats
	//		x.x.x.x - x.x.x.x , xxx , rangename
	//		x.x.x.x-x.x.x.x,xxx,rangename
	//
	//if your webserver can't connect to other servers (fwrappers disabled) you can use local lists ;)
	//$ipblocker_listLocation[] = 'level1.gz';
	
	//to enable a list simply remove the // from the beginning of the list you want to load ;)

	//if your webserver doesn't support fwrappers you try to use the experimental curl support
	$ipblocker_config['use_curl_method'] = false;

	//NOTE: these 3 lists are the biggest ones... so use only the necessary lists :)
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/level1.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/level2.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/level3.gz';
		
	//these others lists instead aren't so big ;)
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/iana-multicast.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/iana-private.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/iana-reserved.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/fornonlancomputers.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/bogon.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/Microsoft.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/trojan.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/spider.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/edu.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/hijacked.txt';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/spyware.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/ads-trackers-and-bad-pr0n.gz';
	//$ipblocker_listLocation[] = 'http://www.bluetack.co.uk/config/dshield.txt';


	//EXCLUSIONS LIST (take care => bigger these lists will be, slower the install/update process will be)
	//$ipblocker_exclusion[] = 'my_exclusion_list.txt';
	//$ipblocker_exclusion[] = 'http://www.bluetack.co.uk/config/exclusions.txt';

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>